<?php
use base\mvc\Application;
use base\mvc\ViewModel;
use base\payments\PaydateCalculator;
class MainController{
    public function indexAction(){
        $config = Application::getConfig();
        $holidays = $config['holidays'];
        $calculator  = new PaydateCalculator();
        return new ViewModel('index', array(
            'holidays' => $holidays,
            'methods' => $calculator->getPaymentMethods()
        ));
    }
    public function calculateAction(){
        $dateOne = $_POST['date-one'];
        $dateTwo = $_POST['date-two'];
        $method = $_POST['payemnt-method'];
        $config = Application::getConfig();
        $calculator = new PaydateCalculator();
        $holidays = (!empty($_POST['holidays']) ? $calculator->generateCustomHolidays($_POST['holidays']) : $config['holidays'] );
        
        $calculator->setHolidays($holidays);
        $dateCount = (int)$_POST['date-count'];
        if(!empty($dateOne) && !empty($dateTwo) && !empty($method)){
            if($dateCount == 0){
                $dates = $calculator->calculateNextPaydates($method, $dateOne, $dateTwo);
            }else{
                $dates = $calculator->calculateNextPaydates($method, $dateOne, $dateTwo, $dateCount);
            }
            
            
        }
        return new ViewModel('index', array(
            'holidays' => $holidays, 
            'calculatedDates' => $dates,
            'dateOne' => $dateOne,
            'dateTwo' => $dateTwo,
            'dateCount' => $dateCount,
            'methods' => $calculator->getPaymentMethods(),
            'method' => $method
        ));
    }
}
