<?php

namespace base\mvc;

use \Exception;

/**
 * Front controller for modules and main application 
 * @author Davit Araqelyan <davaraqelyan111@gmail.com>
 */
class FrontController {

    public static function initModule($dir) {
        self::loadModels($dir);
        $controllName = '';
        $action = '';
        // Grabing action and controller name from request
        // priority is given to POST method
        if (isset($_REQUEST['controller']) && !empty($_REQUEST['controller'])) {
            if (isset($_GET['controller']) && !empty($_GET['controller'])) {
                $controllName = $_GET['controller'];
            }
            if (isset($_POST['controller']) && !empty($_POST['controller'])) {
                $controllName = $_POST['controller'];
            }

            $controllName = trim($_REQUEST['controller']);
            $action = 'default';
            if (isset($_REQUEST['action']) && !empty($_REQUEST['action'])) {
                $action = $_REQUEST['action'];
            }
            if (isset($_GET['action']) && !empty($_GET['action'])) {
                $action = $_GET['action'];
            }
            if (isset($_POST['action']) && !empty($_POST['action'])) {
                $action = $_POST['action'];
            }
        }
        $controllName = (empty($controllName) ? 'Main' : ucfirst($controllName));
        $action = (empty($action) ? 'index' : $action);
        $viewPath = $dir . DS . 'views' . DS . $controllName;
        $defaultLayout = $action;
        $action .= 'Action';
        $controllerPath = $dir . DS . 'controllers' . DS . stripslashes($controllName . 'Controller.php');
       
        if (file_exists($controllerPath)) {
            include_once $controllerPath;
            $controllerClass =  ucfirst($controllName) . 'Controller';
            $currentController = new $controllerClass();

            if (method_exists($currentController, $action)) {
                $viewModel = $currentController->$action();
                // inting view model for current action and rendering layout
                if (is_null($viewModel)) {
                    $viewModel = new ViewModel();
                }
                $viewModel->initControllerInfo(array(
                    'controller' => $controllName,
                    'action' => $defaultLayout
                ));
                $viewModel->setDefaultLayout($defaultLayout);
                $viewModel->setLayoutPath($viewPath);
                $viewModel->render();
            }
            unset($viewModel);
            unset($currentController);
        }
    }
    /**
     * Loading all models for current module
     * @param string $dir current module directory
     */
    private static function loadModels($dir) {
        foreach (glob($dir . DS . 'models' . DS . '*.php') as $file) {
            include_once $file;
        }
    }

}